/**
 * SO, 2010 - Lab #3, Processes
 * Task #2, Linux
 * 
 * fork/exec
 */

#include "utils.h"

int main (int argc, char** argv) {
	pid_t child_pid = fork();
	switch (child_pid) {
		case -1: 
			CHECK(child_pid, "'fork' failed", error);
		case 0: {
			// child
			int execvp_rv = execvp(argv[1], argv + 1);
			// exec can fail
			CHECK(execvp_rv, "'execvp' failed", error);
		}
		default: {
			// parent
			int status;
			do {
	 			pid_t wait_rv = waitpid(child_pid, &status, 0);
				CHECK(wait_rv, "'waitpid' failed", error);
				if (WIFEXITED(status)) {
					printf("Child %d terminated normally, with code %d\n", wait_rv, WEXITSTATUS(status));
				}
				if (WIFSIGNALED(status)) {
					printf("Child %d terminated because signal %d was not caught\n", wait_rv, WTERMSIG(status));
				}
				if (WIFSTOPPED(status)) {
					printf("Child %d stopped with signal %d\n", wait_rv, WSTOPSIG(status));
				}
			}
			while (!WIFEXITED(status) && !WIFSIGNALED(status));

		}
	}

	return 0;

error:
	return EXIT_FAILURE;
}

