/**
 * SO, 2010 - Lab #3, Processes
 * Task #3, Linux
 * 
 * Redirect
 */

#include "utils.h"

int main (int argc, char** argv) {
	int fd = 0;
	pid_t child_pid;

	fd = open("file", O_WRONLY | O_CREAT, 0660);
	CHECK(fd, "'open' for 'file' failed", error);
	
	child_pid = fork();
	switch (child_pid) {
		case -1: 
			CHECK(child_pid, "'fork' failed", clean_fd);
		case 0: {
			// child
			int dup2_rv = dup2(fd, STDOUT_FILENO);
			CHECK(dup2_rv, "'dup2' for the file descriptor of 'file' failed", clean_fd);
			close(fd);
			int execvp_rv = execvp(argv[1], argv + 1);
			CHECK(execvp_rv, "'execvp' failed", clean_fd);
		}
		default: {
			// parent
			close(fd);
			int status;
			do {
	 			pid_t wait_rv = waitpid(child_pid, &status, 0);
				CHECK(wait_rv, "'waitpid' failed", error);
				if (WIFEXITED(status)) {
					printf("Child %d terminated normally, with code %d\n", wait_rv, WEXITSTATUS(status));
				}
				if (WIFSIGNALED(status)) {
					printf("Child %d terminated because signal %d was not caught\n", wait_rv, WTERMSIG(status));
				}
				if (WIFSTOPPED(status)) {
					printf("Child %d stopped with signal %d\n", wait_rv, WSTOPSIG(status));
				}
			}
			while (!WIFEXITED(status) && !WIFSIGNALED(status));

		}
	}

	return 0;

clean_fd:
	close(fd);
error:
	return EXIT_FAILURE;
}

