/**
 * SO, 2010 - Lab #3, Processes
 * Task #4, Linux
 * 
 * Anonymous pipes
 */

#include "utils.h"

int main (int argc, char** argv) {
	int p[2], rd, wr, status;
	pid_t pid;
	
	CHECK(pipe(p), "eroare pipe", error);
	rd = p[0];
	wr = p[1];
	
	setenv("MYVAR", "freedom", 1);
	
	CHECK(pid = fork(), "eroare fork", error);
	switch (pid) {
		// child
		case 0:
			close(wr);
			CHECK(dup2(rd, STDIN_FILENO), "dup2", error);
			CHECK(execlp("./child", "child", NULL), "exec", error);
		// parent
		default:
			close(rd);
			write(wr, "HELLO", 5);
			close(wr);
			
			waitpid(pid, &status, 0);
			printf("PARENT DONE\n");
			break;
	}
	
	return 0;

error:
	return EXIT_FAILURE;

}


