/**
 * SO, 2010 - Lab #3, Processes
 * Task #2, Windows
 * 
 * CreateProcess
 */

#include "utils.h"

int main (int argc, char** argv) {
	PROCESS_INFORMATION pi;
	STARTUPINFO si;
	int result = EXIT_SUCCESS;

	if (argc < 2) {
		fprintf(stderr, "You should provide as argument the name of the file to be executed\n");
		return EXIT_FAILURE;
	}

	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);
	ZeroMemory(&pi, sizeof(pi));
	
	CHECK(
		CreateProcess(
			NULL,
			argv[1],
			NULL,
			NULL,
			FALSE,
			0,
			NULL,
			NULL,
			&si,
			&pi),
		"CreateProcess",
		done);
	
	CHECK(WaitForSingleObject(pi.hProcess, INFINITE) != WAIT_FAILED, "WaitForSingleObject", close_process);
	
close_process:

	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);

done:

	return result;
}
