/**
 * SO, 2010 - Lab #3, Processes
 * Task #3, Windows
 * 
 * Redirect
 */

#include "utils.h"

int main(int argc, char **argv) {
	HANDLE hFile;
	SECURITY_ATTRIBUTES sa;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	int result = EXIT_SUCCESS;

	ZeroMemory(&sa, sizeof(sa));
	sa.bInheritHandle = TRUE;

	hFile = CreateFile(
		"out.txt",
		GENERIC_WRITE,
		FILE_SHARE_READ,
		&sa,
		CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL,
		NULL);
	CHECK(hFile != INVALID_HANDLE_VALUE, "CreateFile", done);

	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);
	si.hStdInput = GetStdHandle(STD_INPUT_HANDLE);
	si.hStdOutput = hFile;
	si.hStdError = GetStdHandle(STD_ERROR_HANDLE);
	si.dwFlags = STARTF_USESTDHANDLES;

	ZeroMemory(&pi, sizeof(pi));

	CHECK(
		CreateProcess(
			NULL,
			argv[1],
			NULL,
			NULL,
			TRUE,
			0,
			NULL,
			NULL,
			&si,
			&pi),
		"CreateProcess", close_file);

	CHECK(WaitForSingleObject(pi.hProcess, INFINITE) != WAIT_FAILED, "WaitForSingleObject", close_process);

close_process:

	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);

close_file:

	CloseHandle(hFile);

done:

	return result;
}