/**
 * SO, 2010 - Lab #3, Processes
 * Task #4, Windows
 * 
 * Anonymous pipes
 */

#include "utils.h"

int main(int argc, char **argv) {
	HANDLE hRead, hWrite;
	SECURITY_ATTRIBUTES sa;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	DWORD dwBytes;
	int result = EXIT_SUCCESS;

	ZeroMemory(&sa, sizeof(sa));
	sa.bInheritHandle = TRUE;

	CHECK(
		CreatePipe(
			&hRead,
			&hWrite,
			&sa,
			0),
		"CreatePipe", done);


	CHECK(SetHandleInformation(hWrite, HANDLE_FLAG_INHERIT, 0), "SetHandleInformation", close_pipe);

	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);
	si.hStdInput = hRead;
	si.hStdOutput = GetStdHandle(STD_OUTPUT_HANDLE);
	si.hStdError = GetStdHandle(STD_ERROR_HANDLE);
	si.dwFlags = STARTF_USESTDHANDLES;

	ZeroMemory(&pi, sizeof(pi));

	CHECK(SetEnvironmentVariable("MYVAR", "freedom"), "SetEnvironmentVariable", done);

	CHECK(
		CreateProcess(
			NULL,
			"child",
			NULL,
			NULL,
			TRUE,
			0,
			NULL,
			NULL,
			&si,
			&pi),
		"CreateProcess", close_pipe);

	CHECK(WriteFile(hWrite, "HELLO", 5, &dwBytes, NULL), "WriteFile", close_process);
	CloseHandle(hWrite);

	CHECK(WaitForSingleObject(pi.hProcess, INFINITE) != WAIT_FAILED, "WaitForSingleObject", close_process);

close_process:

	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);

close_pipe:

	CloseHandle(hWrite);
	CloseHandle(hRead);

done:

	return result;
}