/**
 * SO, 2010 - Lab #3, Processes
 * Task #5, Windows
 * 
 * FIFO
 */

#include "utils.h"

#define BUFSIZE 4096

int main() {
	HANDLE hPipe;
	char buff[10];
	int result = EXIT_SUCCESS, n;
	BOOL res;
	DWORD dwBytes, offset = 0;
	
	hPipe = CreateNamedPipe(
		PIPE_NAME,
		PIPE_ACCESS_INBOUND,
		PIPE_TYPE_BYTE | PIPE_WAIT,
		PIPE_UNLIMITED_INSTANCES,
		BUFSIZE,
		BUFSIZE,
		0,
		NULL);

	CHECK(hPipe != INVALID_HANDLE_VALUE, "CreateNamedPipe", done);

	res = ConnectNamedPipe(hPipe, NULL) ? 
         TRUE : (GetLastError() == ERROR_PIPE_CONNECTED);

	CHECK(res, "ConnectNamedPipe", close_handle);
	
	while (1) {
		res = ReadFile( 
			hPipe,        // handle to pipe 
			buff + offset,    // buffer to receive data 
			sizeof(buff), // size of buffer 
			&dwBytes, // number of bytes read 
			NULL);        // not overlapped I/O 

		if (res == 0 || dwBytes == 0)
			break;

		offset += dwBytes;
	}

	n = *(int*)buff;
	printf("%d\n", n);

	DisconnectNamedPipe(hPipe);

close_handle:

	CloseHandle(hPipe);

done:

	return result;
}
